//////////////////////////////////////////////////////////
// Global defines
// 
// (c) 2009 by Claus N.
//////////////////////////////////////////////////////////
#define null NULL
#define true 1
#define false 0

#define MOUSE_NORMAL 0
#define MOUSE_ATTACK 1

#define STATE_NULL 0
#define STATE_STAND 1
#define STATE_WALK 2
#define STATE_RUN 4
#define STATE_SPECIAL 8	// Disable standard animation
#define STATE_ATTACK (16+STATE_SPECIAL)
#define STATE_ATTACK_NORMAL (STATE_ATTACK)
#define STATE_EVADE (32+STATE_RUN)
#define STATE_CHASE (64+STATE_RUN)
#define STATE_DEAD 128
#define STATE_ATTACK_SECONDARY (256+STATE_ATTACK)
#define STATE_ATTACK_STUN (512+STATE_ATTACK)
#define STATE_STUNNED (1024+STATE_SPECIAL)
#define STATE_REGENERATING (2048+STATE_ATTACK)

#define DEFAULT_ACTOR_WATEREMIT 1
#define DEFAULT_ACTOR_REGENEMIT 4

#define FloatingTextColorPlayer vector(0,255,0)
#define FloatingTextColorEnemy vector(0,0,255)

#define isMouseOver FLAG1

#define movementSpeed skill1
#define range skill2
#define evadeRange skill3
#define meleeRange skill4
#define health skill5
#define max_health skill6
#define damage skill7
#define cooldown skill8

#define speed_x skill21
#define speed_y skill22
#define speed_z skill23
#define spawn_x skill24
#define spawn_y skill25
#define spawn_z skill26
#define target_x skill27
#define target_y skill28
#define target_z skill29

#define ACTOR_STATE skill30
#define ACTOR_COOLDOWN skill31
#define ACTOR_WATEREMIT skill32
#define ACTOR_REGENEMIT skill33

#define ANIM_SPEED_STAND skill40
#define ANIM_SPEED_WALK skill41
#define ANIM_SPEED_RUN skill42
#define ANIM_SPEED_ATTACK skill43
#define ANIM_SPEED_STUN skill44
#define ANIM_SPEED_DEATH skill45
#define ANIM_SPEED_REGENERATE skill46

#define TargetString skill50
//////////////////////////////////////////////////////////
STRING* ANIM_STAND = "stand";
STRING* ANIM_STAND2 = "idle";
STRING* ANIM_WALK = "walk";
STRING* ANIM_RUN = "run";
STRING* ANIM_ATTACK = "attack";
STRING* ANIM_PLAYER_ATTACK_NORMAL = "attack2";
STRING* ANIM_PLAYER_ATTACK_SECONDARY = "attack1";
STRING* ANIM_PLAYER_STUNNED = "pain3";
STRING* ANIM_PLAYER_REGENERATE = "block";

STRING* PlayerTargetString = "#128";
STRING* CombatHelpString = "#128";
STRING* DefEnemyString = "Unknown Enemy";
STRING* CombatOOR = "Target is out of Range!";
STRING* CombatNT = "You don't have a target!";
STRING* CombatTD = "Your target is dead.";
STRING* CombatEvade = "Evading";
STRING* CombatMiss = "Miss";
STRING* CombatStun = "Stunned";
STRING* CombatDead = "Dead";
STRING* CombatRegenerate = "Regenerating";

STRING* EnemyStringSpider = "Sinister Spider";
STRING* EnemyStringSpider2 = "Black Widow Spider";
//////////////////////////////////////////////////////////
FONT* PlayerTargetFont = "Century Gothic#20b";
//////////////////////////////////////////////////////////
ENTITY* PlayerTarget = null;
//////////////////////////////////////////////////////////
var cameraPan = 0;
var cameraTilt = -20;
var cameraRotatePan = 0;
var cameraZoom = 120;
var cameraZoomMin = 50;
var cameraZoomMax = 300;

var movementSpeedWalkFactor = 0.4;
var movementSpeedRunSpellFactor = 1;

var MouseEnabled;
var MouseType = MOUSE_NORMAL;

var UIVAR_PlayerHealth = 0;
var UIVAR_TargetHealth = 0;
//////////////////////////////////////////////////////////
BMAP* MouseMap = "arrow.pcx";
BMAP* MouseMapAttack = "MouseMapAttack.tga";

BMAP* TerrainTexMap1 = "tilegrass2.bmp";
BMAP* TerrainTexMap2 = "tilesand2.bmp";
BMAP* TerrainBlendMap = "terrainblendtex.bmp";

BMAP* HealthBarBG = "HealthbarBG.tga";
BMAP* HealthbarMap = "Healthbar.tga";
BMAP* HealthbarTargetMap = "healthbarTarget.tga";

BMAP* Particle_WhiteMap = "particle_white.tga";
//////////////////////////////////////////////////////////
void EnableMouse();
void cameraAlphaFade();
void attach_to_ground();
void animate_me();
void WaterlevelTrail();
void RegenerateEffect();
void TargetableEntity();
void SetCombatText(STRING* combatStr);
void FloatingCombatText(STRING* _combatStr,VECTOR* color,VECTOR* _position);
void KeyEvent_Space();
//////////////////////////////////////////////////////////
