//////////////////////////////////////////////////////////
// Player script
// 
// (c) 2009 by Claus N.
//////////////////////////////////////////////////////////
void setCamera();
//////////////////////////////////////////////////////////
action RPGPlayer()
{
	player = me;
	cameraPan = my.pan;
	
	STRING* CombatString = "#32";
	
	if(my.movementSpeed == 0) {my.movementSpeed = 10;}
	if(my.meleeRange == 0) {my.meleeRange = 80;}
	if(my.max_health == 0) {my.max_health = 100;}
	if(my.health == 0) {my.health = my.max_health;}
	if(my.damage == 0) {my.damage = 12;}
	if(my.cooldown == 0) {my.cooldown = 10;}
	
	my.ANIM_SPEED_STAND = 1;
	my.ANIM_SPEED_WALK = 5;
	my.ANIM_SPEED_RUN = 10;
	my.ANIM_SPEED_ATTACK = 10;
	my.ANIM_SPEED_STUN = 5;
	my.ANIM_SPEED_DEATH = 8;
	my.ANIM_SPEED_REGENERATE = 4;
	
	int moveForward = 0;
	
	while(my.health > 0)
	{
		moveForward = (key_w | (mouse_left & mouse_right));
		
		setCamera();
		cameraAlphaFade();
		attach_to_ground();
		animate_me();
		WaterlevelTrail();
		RegenerateEffect();
		
		UIVAR_PlayerHealth = clamp((100 - my.health) / 100 * 376,0,376);
		
		my.ACTOR_COOLDOWN = maxv(my.ACTOR_COOLDOWN - 1 * time_step,0);
		
		///////////// - Allow attacking - /////////////
		
		if((my.ACTOR_STATE & STATE_SPECIAL) == 0)
		{
			if(PlayerTarget != null)
			{
				if(key_e | key_q)
				{
					if((PlayerTarget.ACTOR_STATE & STATE_DEAD) != 0)
					{
						if(key_e | key_q) {SetCombatText(CombatTD);}
					}
					else
					{
						if(key_e && my.ACTOR_COOLDOWN <= 0)
						{
							if(vec_dist(my.x,PlayerTarget.x) > my.meleeRange)
							{
								SetCombatText(CombatOOR);
							}
							else
							{
								my.skill48 = 0;
								my.ACTOR_STATE = STATE_ATTACK_NORMAL;
								my.ACTOR_COOLDOWN = my.cooldown;
							}
						}
						else if(key_q && my.ACTOR_COOLDOWN <= 0)
						{
							if(vec_dist(my.x,PlayerTarget.x) > my.meleeRange)
							{
								SetCombatText(CombatOOR);
							}
							else
							{
								my.skill48 = 0;
								my.ACTOR_STATE = STATE_ATTACK_SECONDARY;
								my.ACTOR_COOLDOWN = my.cooldown;
							}
						}
					}
				}
				else if(key_f)
				{
					my.ACTOR_STATE = STATE_REGENERATING;
					my.skill48 = 0;
					FloatingCombatText(CombatRegenerate,FloatingTextColorPlayer,my.x);
				}
			}
			else
			{
				if(key_e | key_q) {SetCombatText(CombatNT);}
				else if(key_f)
				{
					my.ACTOR_STATE = STATE_REGENERATING;
					my.skill48 = 0;
					FloatingCombatText(CombatRegenerate,FloatingTextColorPlayer,my.x);
				}
			}
		}
		else if(my.ACTOR_STATE == STATE_ATTACK_NORMAL)
		{
			my.skill48 += my.ANIM_SPEED_ATTACK * time_step;
			
			if(my.skill48 > 95)
			{
				if((PlayerTarget.ACTOR_STATE & STATE_EVADE) == 0)
				{
					if(random(100) > 20)
					{
						PlayerTarget.health -= my.damage;
						
						str_for_num(CombatString,my.damage);
						FloatingCombatText(CombatString,FloatingTextColorPlayer,PlayerTarget.x);
					}
					else
					{
						FloatingCombatText(CombatMiss,FloatingTextColorPlayer,PlayerTarget.x);
					}
				}
				else
				{
					FloatingCombatText(CombatEvade,FloatingTextColorPlayer,PlayerTarget.x);
				}
				
				my.ACTOR_STATE = STATE_STAND;
			}
			else
			{
				ent_animate(my,ANIM_PLAYER_ATTACK_NORMAL,my.skill48,null);
			}
		}
		else if(my.ACTOR_STATE == STATE_ATTACK_SECONDARY)
		{
			my.skill48 += my.ANIM_SPEED_ATTACK * time_step;
			
			if(my.skill48 > 95)
			{
				if((PlayerTarget.ACTOR_STATE & STATE_EVADE) == 0)
				{
					if(random(100) > 50)
					{
						you = PlayerTarget;
						
						PlayerTarget.health -= my.damage * 2;
						
						str_for_num(CombatString,my.damage * 2);
						FloatingCombatText(CombatString,FloatingTextColorPlayer,PlayerTarget.x);
					}
					else
					{
						FloatingCombatText(CombatMiss,FloatingTextColorPlayer,PlayerTarget.x);
					}
				}
				else
				{
					FloatingCombatText(CombatEvade,FloatingTextColorPlayer,PlayerTarget.x);
				}
				
				my.ACTOR_STATE = STATE_STAND;
			}
			else
			{
				ent_animate(my,ANIM_PLAYER_ATTACK_SECONDARY,my.skill48,null);
			}
		}
		else if(my.ACTOR_STATE == STATE_STUNNED)
		{
			if(my.skill48 > 95)
			{
				my.ACTOR_STATE = STATE_STAND;
			}
			else
			{
				ent_animate(my,ANIM_PLAYER_STUNNED,my.skill48,null);
				my.skill48 += my.ANIM_SPEED_STUN * time_step;
			}
		}
		else if(my.ACTOR_STATE == STATE_REGENERATING)
		{
			if(my.skill48 > 95)
			{
				my.ACTOR_STATE = STATE_STAND;
				my.health = clamp(my.health + 20,0,my.max_health);
			}
			else
			{
				ent_animate(my,ANIM_PLAYER_REGENERATE,my.skill48,null);
				my.skill48 += my.ANIM_SPEED_REGENERATE * time_step;
			}
		}
		
		////////////// - Turning Begin - //////////////
		if(moveForward | key_s)
		{
			my.speed_x = -sign(key_s - moveForward*2);
		}
		
		if(mouse_right && my.health > 0 && my.ACTOR_STATE != STATE_REGENERATING)
		{
			my.pan = cameraPan;
		}
		
		if(key_a | key_d)
		{
			my.speed_x = sign(key_a | key_d);
			
			if(mouse_right)
			{
				if(moveForward | key_s)
				{
					my.pan = cameraPan + sign(key_a - key_d*2)*45;
				}
				else
				{
					my.pan = cameraPan + sign(key_a - key_d*2)*90;
				}
			}
			else
			{
				my.pan += sign(key_a - key_d*2)*15 * time_step;
				cameraRotatePan += sign(key_a - key_d*2)*15 * time_step;
			}
		}
		////////////// - Turning End - ////////////////
		
		if(moveForward | key_s | key_a | key_d)
		{
			if(key_shift)
			{
				my.speed_x = my.speed_x * my.movementSpeed * movementSpeedWalkFactor * time_step;
				
				if((my.ACTOR_STATE & STATE_SPECIAL) == 0) {my.ACTOR_STATE = STATE_WALK;}
			}
			else
			{
				my.speed_x = my.speed_x * my.movementSpeed * movementSpeedRunSpellFactor * time_step;
				
				if((my.ACTOR_STATE & STATE_SPECIAL) == 0) {my.ACTOR_STATE = STATE_RUN;}
			}
		}
		else
		{
			my.speed_x = 0;
			
			if((my.ACTOR_STATE & STATE_SPECIAL) == 0) {my.ACTOR_STATE = STATE_STAND;}
		}
		
		if((my.ACTOR_STATE & STATE_SPECIAL) == 0)
		{
			c_move(my,my.speed_x,nullvector,IGNORE_MODELS + GLIDE);
		}
		
		wait(1);
	}
	
	my.ACTOR_STATE = STATE_DEAD;
	
	UIVAR_PlayerHealth = clamp((100 - my.health) / 100 * 376,0,376);
	
	my.skill48 = 0;
	
	while(my.skill48 < 100)
	{
		setCamera();
		ent_animate(my,"death2",my.skill48,null);
		my.skill48 += my.ANIM_SPEED_DEATH * time_step;
		
		wait(1);
	}
	
	while(my) {setCamera();wait(1);}
}
//////////////////////////////////////////////////////////
void setCamera()
{
	camera.x = my.x + fcos(cameraPan,-cameraZoom);
	camera.y = my.y + fsin(cameraPan,-cameraZoom);
	camera.z = my.z + fsin(cameraTilt,-cameraZoom);
	
	camera.z = maxv(camera.z,10);
	
	c_trace(my.x,camera.x,IGNORE_MODELS + IGNORE_PASSABLE);
	if(result > 0)
	{
		vec_set(camera.x,target);
		vec_scale(normal,5);
		vec_add(camera.x,normal);
	}
	
	vec_set(target,my.x);
	vec_sub(target,camera.x);
	vec_to_angle(camera.pan,target);
	
	if(mouse_right || mouse_left)
	{
		cameraPan -= mouse_force.x * 30 * time_step;
		cameraTilt += mouse_force.y * 30 * time_step;
		
		cameraRotatePan = 0;
	}
	else if(cameraRotatePan != 0)
	{
		if(abs(cameraRotatePan) >= 5)
		{
			cameraPan += sign(cameraRotatePan) * 5 * time_step;
		}
		else
		{
			cameraPan += cameraRotatePan;
			cameraRotatePan = 0;
		}
	}
	
	cameraZoom = clamp(cameraZoom - mickey.z * time_step,cameraZoomMin,cameraZoomMax);
	
	cameraTilt = clamp(cameraTilt,-90,90);
}
//////////////////////////////////////////////////////////
void cameraAlphaFade()
{
	if(vec_dist(my.x,camera.x) < 100)
	{
		my.flags |= TRANSLUCENT;
		
		if(my.alpha > vec_dist(my.x,camera.x))
		{
			my.alpha -= 10 * time_step;
		}
	}
	else
	{
		if(my.alpha < 95)
		{
			my.alpha += 10 * time_step;
		}
		else
		{
			my.flags &= ~TRANSLUCENT;
		}
	}
}
//////////////////////////////////////////////////////////
void attach_to_ground()
{
	vec_set(target,my.x);
	vec_set(normal,my.x);
	normal.z -= 2000;
	
	result = c_trace(target,normal,IGNORE_MODELS + IGNORE_PASSABLE);
	
	if(result > 0)
	{
		my.z = target.z - my.min_z;
	}
}
//////////////////////////////////////////////////////////
void animate_me()
{
	if((my.ACTOR_STATE & STATE_SPECIAL) == 0)
	{
		if((my.ACTOR_STATE & STATE_STAND) != 0)
		{
			ent_animate(me,ANIM_STAND,my.skill48,ANM_CYCLE);
			ent_animate(me,ANIM_STAND2,my.skill48,ANM_CYCLE);
			my.skill48 += my.ANIM_SPEED_STAND * time_step;
			my.skill48 %= 100;
		}
		
		if((my.ACTOR_STATE & STATE_WALK) != 0)
		{
			ent_animate(me,ANIM_WALK,my.skill48,ANM_CYCLE);
			my.skill48 += my.ANIM_SPEED_WALK * time_step;
			my.skill48 %= 100;
		}
		
		if((my.ACTOR_STATE & STATE_RUN) != 0)
		{
			ent_animate(me,ANIM_RUN,my.skill48,ANM_CYCLE);
			my.skill48 += my.ANIM_SPEED_RUN * time_step;
			my.skill48 %= 100;
		}
	}
}
//////////////////////////////////////////////////////////
void WaterlevelTrail()
{
	if(my.ACTOR_WATEREMIT > 0)
	{
		my.ACTOR_WATEREMIT -= 1 * time_step;
	}
	else if(my.z + my.min_z < 5 && my.z + my.max_z > -5)
	{
		my.ACTOR_WATEREMIT = DEFAULT_ACTOR_WATEREMIT;
		
		int i;
		
		for(i = ent_vertices(my);i > 0;i--)
		{
			vec_for_vertex(target,my,i);
			
			if(target.z > -2 && target.z < 2)
			{
				if(abs(my.speed_x) == 0)
				{
					my.ACTOR_WATEREMIT = DEFAULT_ACTOR_WATEREMIT * 3;
					target.x += random(5) - random(5);
					target.y += random(5) - random(5);
				}
				
				effect(WaterParticleTrail,1,target,nullvector);
			}
		}
	}
}
//////////////////////////////////////////////////////////
void RegenerateEffect()
{
	if(my.ACTOR_REGENEMIT > 0)
	{
		my.ACTOR_REGENEMIT -= 1 * time_step;
	}
	else if(my.ACTOR_STATE == STATE_REGENERATING && my.skill48 < 75)
	{
		my.ACTOR_REGENEMIT = DEFAULT_ACTOR_REGENEMIT;
		
		int i;
		
		for(i = ent_vertices(my);i > 0;i-=2)
		{
			vec_for_vertex(target,my,i);
			
			effect(RegenerationParticles,1,target,nullvector);
		}
	}
}
//////////////////////////////////////////////////////////
